<?php
	$relations = Array(
		'cms3_domain_mirrows' => Array(
			'CONSTRAINT "FK_Domain to mirrows relation" FOREIGN KEY ("rel") REFERENCES "cms3_domains" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_domains' => Array(
			'CONSTRAINT "FK_Domain to default language relation" FOREIGN KEY ("default_lang_id") REFERENCES "cms3_langs" ("id") ON DELETE SET NULL ON UPDATE CASCADE',
		),
	
		'cms3_fields_controller' => Array(
			'CONSTRAINT "FK_rel to field" FOREIGN KEY ("field_id") REFERENCES "cms3_object_fields" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_rel to field group" FOREIGN KEY ("group_id") REFERENCES "cms3_object_field_groups" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_hierarchy' => Array(
			'CONSTRAINT "FK_Domain from domain_id relation" FOREIGN KEY ("domain_id") REFERENCES "cms3_domains" ("id") ON UPDATE CASCADE',
			'CONSTRAINT "FK_Getting template data" FOREIGN KEY ("tpl_id") REFERENCES "cms3_templates" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_hierarchy to plain object image" FOREIGN KEY ("obj_id") REFERENCES "cms3_objects" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_Prefix from lang_id" FOREIGN KEY ("lang_id") REFERENCES "cms3_langs" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_types rels" FOREIGN KEY ("type_id") REFERENCES "cms3_hierarchy_types" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_hierarchy_relations' => Array(
			'CONSTRAINT "Hierarchy relation by rel_id" FOREIGN KEY ("rel_id") REFERENCES "cms3_hierarchy" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "Hierarchy relation by child_id" FOREIGN KEY ("child_id") REFERENCES "cms3_hierarchy" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_import_fields' => Array(
			'CONSTRAINT "FK_FieldSourceId_To_Source" FOREIGN KEY ("source_id") REFERENCES "cms3_import_sources" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_NewFieldId_To_ObjectTypeId" FOREIGN KEY ("type_id") REFERENCES "cms3_import_types" ("new_id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_NewId_To_ObjectTypeFieldId" FOREIGN KEY ("new_id") REFERENCES "cms3_object_fields" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_import_relations' => Array(
			'CONSTRAINT "FK_NewId_To_HierarchyId" FOREIGN KEY ("new_id") REFERENCES "cms3_hierarchy" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_SourceId_To_Source" FOREIGN KEY ("source_id") REFERENCES "cms3_import_sources" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_import_types' => Array(
			'CONSTRAINT "FK_NewId_To_ObjectTypeId" FOREIGN KEY ("new_id") REFERENCES "cms3_object_types" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_TypeSourceId_To_Source" FOREIGN KEY ("source_id") REFERENCES "cms3_import_sources" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_object_content' => Array(
			'CONSTRAINT "FK_Content to object relation" FOREIGN KEY ("obj_id") REFERENCES "cms3_objects" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_content2tree" FOREIGN KEY ("tree_val") REFERENCES "cms3_hierarchy" ("id") ON DELETE CASCADE',
			'CONSTRAINT "FK_Contents field id relation" FOREIGN KEY ("field_id") REFERENCES "cms3_object_fields" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_Relation value reference" FOREIGN KEY ("rel_val") REFERENCES "cms3_objects" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_object_field_groups' => Array(
			'CONSTRAINT "FK_Group to type relation" FOREIGN KEY ("type_id") REFERENCES "cms3_object_types" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_object_fields' => Array(
			'CONSTRAINT "FK_Field to field type relation" FOREIGN KEY ("field_type_id") REFERENCES "cms3_object_field_types" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		),
	
		'cms3_objects' => Array(
			'CONSTRAINT "FK_Object to type relation" FOREIGN KEY ("type_id") REFERENCES "cms3_object_types" ("id")',
		),
	
		'cms3_permissions' => Array(
			'CONSTRAINT "FK_owner reference" FOREIGN KEY ("owner_id") REFERENCES "cms3_objects" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
			'CONSTRAINT "FK_rel reference" FOREIGN KEY ("rel_id") REFERENCES "cms3_hierarchy" ("id") ON DELETE CASCADE ON UPDATE CASCADE',
		)
	);

	$innodb = Array('cms3_langs', 'cms3_object_types', 'cms3_object_field_types', 'cms3_hierarchy_types', 'cms3_import_sources', 'cms3_search', 'cms3_search_index', 'cms3_search_index_words', 'cms3_templates', 'cms_backup', 'cms_permissions', 'cms_reg');
	
	header("Content-type: text/plain; charset=utf-8");

	require "./mysql.php";

	mysql_query("SET AUTOCOMMIT=0");
	mysql_query("SET FOREIGN_KEY_CHECKS=0");

	foreach($innodb as $tableName) {
		echo "Fixing table {$tableName}\n";
		mysql_query("ALTER TABLE `{$tableName}` ENGINE=InnoDB");
		echo "\n";
		flush();
	}

	foreach($relations as $tableName => $rels) {
		echo "Fixing table {$tableName}\n";
		
		mysql_query("ALTER TABLE `{$tableName}` ENGINE=InnoDB");
		foreach($rels as $const) {
			if(preg_match("/CONSTRAINT \"([^\"]+)\"/", $const, $out)) {
				$constName = $out[1];
			} else {
				$constName = false;
			}
			if(!$constName) continue;
			
			echo "\tRecreate key {$constName}\n";
			
			mysql_query("ALTER TABLE `{$tableName}` DROP FOREIGN KEY `{$constName}`");

			$sql = "ALTER TABLE `{$tableName}` ADD " . $const;
			$sql = str_replace("\"", "`", $sql);
			mysql_query($sql);

			if($err = mysql_error()) {
				echo "\n\n\nError in sql:\n{$sql}\nDescription: {$err}\n\n";
			}
		}
		echo "\n";
		flush();
	}

	mysql_query("COMMIT");
	mysql_query("SET AUTOCOMMIT=1");
	mysql_query("SET FOREIGN_KEY_CHECKS=1");
?>